local WaterMill = ...

--------------------------------------------------------------------------
local WATER_MILL_COMP_CHECK_WHEEL = {
	TypeName = "WATER_MILL_COMP_CHECK_WHEEL",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "WheelOffsetY", Type = "float", Default = 1.0 },
		{ Name = "FlagTested", Type = "integer", Default = 2 ^ OBJECT_FLAG.WATER:toNumber() }
	}
}

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:create()
	self._timer = 0
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:init()
        WaterMill:log("init")
        self:checkOnWater()
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:checkOnWater()
    WaterMill:log("checkOnWater")

    local raycastResult = {}
    WaterMill:log("initial raycastResult = " .. tostring(raycastResult))
     
    WaterMill:log("flag = " .. tostring(self.FlagTested))
     
    -- Raycast from the building position + Y = 10
    -- to building position - y = 100
    -- only on objects with a WATER flag
    self.FromPosition = self:getOwner():getGlobalPosition()
    WaterMill:log("FromPosition = " .. tostring(self.FromPosition))
    self.FromPosition[2] = self.FromPosition[2] - self.WheelOffsetY + 0.5 
    self.ToPosition = self.FromPosition
    self.ToPosition[2] = self.ToPosition[2] - self.WheelOffsetY - 0.5
    WaterMill:log("FromPosition = " .. tostring(self.FromPosition) .. "ToPosition = " .. tostring(self.ToPosition))
    self:getLevel():rayCast(self.FromPosition, self.ToPosition, raycastResult, self.FlagTested)
    WaterMill:log("final raycastResult = RigidBody = " .. tostring(raycastResult["RigidBody"]) .. " Position = " .. tostring(raycastResult["Position"]) .. " Normal = " .. tostring(raycastResult["Normal"]))
    if raycastResult["RigidBody"] == nil then
         WaterMill:logWarning("Water Mill Set: Wheel NOT on water")
    else
         WaterMill:log("Water Mill Set: Wheel on water")
    end
end
--------------------------------------------------------------------------
function WATER_MILL_COMP_CHECK_WHEEL:update()
end

--------------------------------------------------------------------------
WaterMill:registerClass(WATER_MILL_COMP_CHECK_WHEEL)

--------------------------------------------------------------------------
local WATER_MILL_COMP_WHEEL = {
	TypeName = "WATER_MILL_COMP_WHEEL",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "RotationSpeedX", Type = "float", Default = 0.5 },
		{ Name = "RotationDirectionCustom", Type = "string", Default = "Woop" }
	}
}

--------------------------------------------------------------------------
function WATER_MILL_COMP_WHEEL:create()
	self._timer = 0
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_WHEEL:init()
         WaterMill:log("init")
	self._rotationX = 0 --self.MinAngleX + math.random() * (self.MaxAngleX - self.MinAngleX)
	self._rotationY = 0 --math.random() * math.pi
        WaterMill:log("RotationDirectionCustom = " .. self.RotationDirectionCustom)
end

--------------------------------------------------------------------------
function WATER_MILL_COMP_WHEEL:update()
	local dt = self:getLevel():getDeltaTime()
        if self.RotationDirectionCustom == "RIGHT_BANK" then
	    self._rotationX = self._rotationX - self.RotationSpeedX * dt
	else
	    self._rotationX = self._rotationX + self.RotationSpeedX * dt
        end
	self:getOwner():setRotationX(self._rotationX)
--	self:getOwner():translate({ 0, dt,  0})
end

--------------------------------------------------------------------------
WaterMill:registerClass(WATER_MILL_COMP_WHEEL)
